searchNodes=[{"doc":"Advent of Code solution module macro and helpers. This module contains the aoc/3 macro, which should be used to write a solution module for a given advent of code challenge. The intended use is to write your solution for day &lt;day&gt; , year &lt;year&gt; as follows: import AOC aoc &lt; year &gt; , &lt; day &gt; do def p1 do # Part 1 solution goes here end def p2 do # Part 1 solution goes here end end Defining a module with the aoc/3 macro has a few advantages: Helper functions to access the input and examples (if present) are inserted into the generated module. The AOC.IEx functions can be used to call your solutions in the module, making your life a bit easier. Overall, the aoc/3 macro is intended to allow you to forego writing boilerplate code which is shared between all the solutions. Note that the code skeleton shown above can be generated by running mix aoc.gen or mix aoc . aoc/3 and use AOC Internally, aoc/3 generates a module with a predefined name ( Y&lt;year&gt;.D&lt;day&gt; ) which contains a use AOC, day: &lt;day&gt;, year: &lt;year&gt; statement. In turn, the __using__/1 macro defined in this module is responsible for generating helper functions. Thus, if you prefer to use a different naming scheme than the one imposed by aoc/3 , you can write your module as follows: defmodule MySolution do use AOC , day : &lt; day &gt; , year : &lt; year &gt; ... end When the AOC module is used like this, the helper functions defined below are still usable, but the helpers in AOC.IEx will not work. Helper functions This module defines various functions such as input_path/2 , input_string/2 , input_stream/2 and their example_*/2 counter parts. Inside the generated module, helpers are inserted which call these functions with the module's day / year. Thus, if you call input_path() inside your solution module, it will call input_path/2 for you with the module's day and year, obtaining the path to the appropriate input file. The following table provides an overview of the inserted functions and their counterparts in this module: Generated Calls input_path/0 input_path/2 input_string/0 input_string/2 input_stream/0 input_stream/2 example_path/0 example_path/2 example_string/0 example_string/2 example_stream/0 example_stream/2 The generated functions are overridable, i.e. you can define your own version of these functions which will overwrite the generated function. This is handy to do something like the following: def input_stream , do : super ( ) |&gt; Stream . map ( &amp; String . to_integer / 1 )","ref":"AOC.html","title":"AOC","type":"module"},{"doc":"Generate an advent of code solution module for a given year and day. The generated module will be named Y&lt;year&gt;.D&lt;day&gt; . use AOC will be injected in the body of the module, so that the input helpers described in the module documentation are available. Examples import AOC aoc 2020 , 1 do def some_function do :foo end end is equivalent to: defmodule Y2020.D1 do use AOC , year : 2020 , day : 1 def some_function do :foo end end","ref":"AOC.html#aoc/3","title":"AOC.aoc/3","type":"macro"},{"doc":"Get the example path for year , day . Obtains the path where mix aoc.get stores the input for year , day . This path defaults to input/&lt;year&gt;_&lt;day&gt;_example.txt , but can be customized. Please refer to the mix aoc.get documentation for more information.","ref":"AOC.html#example_path/2","title":"AOC.example_path/2","type":"function"},{"doc":"Stream the contents of the example for year , day . The stream is created by calling File.stream!/1 on the path returned by example_path/2 . Afterwards, String.trim/1 is mapped over the stream (using Stream.map/2 ), to remove trailing newlines and whitespace.","ref":"AOC.html#example_stream/2","title":"AOC.example_stream/2","type":"function"},{"doc":"Get the example contents of year , day . Obtained by calling File.read!/1 on the path returned by example_path/2 . String.trim_trailing/1 is called on the resulting string to remove trailing whitespace.","ref":"AOC.html#example_string/2","title":"AOC.example_string/2","type":"function"},{"doc":"Get the input path for year , day . Obtains the path where mix aoc.get stores the input for year , day . This path defaults to input/&lt;year&gt;_&lt;day&gt;.txt , but can be customized. Please refer to the mix aoc.get documentation for more information.","ref":"AOC.html#input_path/2","title":"AOC.input_path/2","type":"function"},{"doc":"Stream the contents of the input for year , day . The stream is created by calling File.stream!/1 on the path returned by input_path/2 . Afterwards, String.trim/1 is mapped over the stream (using Stream.map/2 ), to remove trailing newlines and whitespace.","ref":"AOC.html#input_stream/2","title":"AOC.input_stream/2","type":"function"},{"doc":"Get the input contents of year , day . Obtained by calling File.read!/1 on the path returned by input_path/2 . String.trim_trailing/1 is called on the resulting string to remove trailing whitespace.","ref":"AOC.html#input_string/2","title":"AOC.input_string/2","type":"function"},{"doc":"IEx helpers for advent of code. This module contains various helpers that make it easy to call procedures in your solution modules. This is particularly useful when you are testing your solutions from within iex. In order to avoid prefixing all calls with AOC.IEx , we recommend adding import AOC.IEx to your .iex.exs file . Requirements and AOC.aoc/3 In order to find a module for a given day and year, this module expects the module to have the name Y&lt;year&gt;.D&lt;day&gt; . This is automatically the case if the AOC.aoc/3 macro was used to build the solution module. Besides this, it is expected that the solutions for part 1 and part 2 are defined in non-private functions named p1 and p2 . Using this module The p1/0 and p2/0 functions can be used to call the p1 and p2 functions of your solution module. By default, these functions are called on the module that represents the current day. The current day (and year) is determined by NaiveDateTime.local_now/0 . If it is past midnight, or if you wish to solve an older challenge, there are a few options at your disposal: p1/2 and p2/2 accept a day and year argument. p1/1 and p1/1 accept a day argument and uses the current year by default. The current year and day can be configured through the :advent_of_code_utils application environment. For instance, you can set the year to 1991 and the day to 8 by placing the following in your config/config.exs : import Config config :advent_of_code_utils , day : 8 , year : 1991 To summarise, the day or year is determined according to the following rules: If year or day was passed as an argument (to p1/2 , p1/1 , p2/2 or p2/1 ) it is always used. If :year or :day is present in the :advent_of_code_utils application environment, it is used. The year or day returned by NaiveDateTime.local_now/0 is used. Automatic recompilation It is often necessary to recompile the current mix project before running p1 or p2 . To avoid manually doing this, all the functions in this module will recompile the current mix project (with IEx.Helpers.recompile/1 ) before calling p1 or p2 when :auto_compile? is set to true in the :advent_of_code_utils application environment. Auto reload can be enabled by adding the following to your config/config.exs : import Config config :advent_of_code_utils , auto_compile? : true","ref":"AOC.IEx.html","title":"AOC.IEx","type":"module"},{"doc":"Get the module name for the current or configured day and year . day and year are fetched from the application environment, the local time is used if they are not available. Please refer to the module documentation for additional information. This function may cause recompilation if auto_compile? is enabled. Examples iex&gt; Application . put_env ( :advent_of_code_utils , :year , 1991 ) iex&gt; Application . put_env ( :advent_of_code_utils , :day , 8 ) iex&gt; mod ( ) Y1991.D8 iex&gt; Application . put_env ( :advent_of_code_utils , :year , 2000 ) iex&gt; Application . put_env ( :advent_of_code_utils , :day , 3 ) iex&gt; mod ( ) Y2000.D3","ref":"AOC.IEx.html#mod/0","title":"AOC.IEx.mod/0","type":"function"},{"doc":"Get the module name for day , lookup year . year is fetched from the application environment, otherwise the local time is used. Please refer to the module documentation for additional information. This function may cause recompilation if auto_compile? is enabled. Examples iex&gt; Application . put_env ( :advent_of_code_utils , :year , 1991 ) iex&gt; mod ( 8 ) Y1991.D8 iex&gt; Application . put_env ( :advent_of_code_utils , :year , 2000 ) iex&gt; mod ( 3 ) Y2000.D3","ref":"AOC.IEx.html#mod/1","title":"AOC.IEx.mod/1","type":"function"},{"doc":"Get the module name for year , day . This function may cause recompilation if auto_compile? is enabled. Examples iex&gt; mod ( 1991 , 8 ) Y1991.D8","ref":"AOC.IEx.html#mod/2","title":"AOC.IEx.mod/2","type":"function"},{"doc":"Call Y&lt;year&gt;.D&lt;day&gt;.p1() day and year are fetched from the application environment, the local time is used if they are not available. Please refer to the module documentation for additional information. This function may cause recompilation if auto_compile? is enabled.","ref":"AOC.IEx.html#p1/0","title":"AOC.IEx.p1/0","type":"function"},{"doc":"Call Y&lt;year&gt;.D&lt;day&gt;.p1() year is fetched from the application environment, the local time is used if it is not available. Please refer to the module documentation for additional information. This function may cause recompilation if auto_compile? is enabled.","ref":"AOC.IEx.html#p1/1","title":"AOC.IEx.p1/1","type":"function"},{"doc":"Call Y&lt;year&gt;.D&lt;day&gt;.p1() This function may cause recompilation if auto_compile? is enabled.","ref":"AOC.IEx.html#p1/2","title":"AOC.IEx.p1/2","type":"function"},{"doc":"Call Y&lt;year&gt;.D&lt;day&gt;.p2() day and year are fetched from the application environment, the local time is used if they are not available. Please refer to the module documentation for additional information. This function may cause recompilation if auto_compile? is enabled.","ref":"AOC.IEx.html#p2/0","title":"AOC.IEx.p2/0","type":"function"},{"doc":"Call Y&lt;year&gt;.D&lt;day&gt;.p2() year is fetched from the application environment, the local time is used if it is not available. Please refer to the module documentation for additional information. This function may cause recompilation if auto_compile? is enabled.","ref":"AOC.IEx.html#p2/1","title":"AOC.IEx.p2/1","type":"function"},{"doc":"Call Y&lt;year&gt;.D&lt;day&gt;.p2() This function may cause recompilation if auto_compile? is enabled.","ref":"AOC.IEx.html#p2/2","title":"AOC.IEx.p2/2","type":"function"},{"doc":"Create a code skeleton and fetch input for the AOC challenge of a day / year. This mix task runs mix aoc.gen followed by mix aoc.get . Afterwards, it prints the url of today's challenge. mix aoc.gen This task generates a code skeleton for the given day and year in lib/&lt;year&gt;/&lt;day&gt;.ex , which uses the AOC.aoc/3 macro. To customise the path where code is stored, refer to the mix aoc.gen documentation. mix aoc.get This task fetches the input and example input for a given day and year and stores it in input/&lt;year&gt;_&lt;day&gt;.txt and input/&lt;year&gt;_&lt;day&gt;_example.txt . In order for this task to work, your session cookie should be passed as a command line argument or set up in the :advent_of_code_utils application environment. Please refer to the mix aoc.get documentation for more information. Command-line arguments -s or --session : Specify the session cookie. -y or --year : Specify the year. -d or --day : Specify the day. --example : Fetch example input (the default) --no-example : Do not fetch example input All of these options take precedence over their application environment counterparts.","ref":"Mix.Tasks.Aoc.html","title":"Mix.Tasks.Aoc","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Aoc.html#run/1","title":"Mix.Tasks.Aoc.run/1","type":"function"},{"doc":"Create a code skeleton for the AOC challenge of a given day / year. This mix task creates a code skeleton for the advent of code challenge of a specific day. The day and year of the challenge can be passed as command-line arguments or be set in the advent_of_code_utils application configuration. When neither of these are present, the current date is used. By default, this task stores the generated code skeleton in lib/&lt;year&gt;/&lt;day&gt;.ex . If this file already exists, an error is returned and no files are created. The destination path can be modified by setting the value of :code_path in the advent_of_code_utils application configuration. This value should be set to a string which may contain :year and :day . These values will be replaced by the day and year for which a skeleton is generated. For instance, the following configuration will store the generated code in lib/aoc_&lt;year&gt;_day_&lt;day&gt;.ex : config :advent_of_code_utils , :code_path , &quot;lib/aoc_:year_day_:day.ex&quot; Command-line arguments The options below take precedence over values defined in the application configuration. -y or --year : Specify the year. -d or --day : Specify the day.","ref":"Mix.Tasks.Aoc.Gen.html","title":"Mix.Tasks.Aoc.Gen","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Aoc.Gen.html#run/1","title":"Mix.Tasks.Aoc.Gen.run/1","type":"function"},{"doc":"Fetch the input and example input of the AOC challenge for a given day / year. This mix task fetches the input and example input for the advent of code challenge of a specific day. The day and year of the challenge can be passed as command-line arguments or be set in the advent_of_code_utils application configuration. When neither is present, the current date is used. By default, this task stores the fetched input data in input/&lt;year&gt;_&lt;day&gt;.txt . The fetched example is stored in input/&lt;year&gt;_&lt;day&gt;_example.txt . If a file already exists, the matching input is not fetched. The destination paths can be modified by setting the value of :input_path or :example_path in the advent_of_code_utils application configuration. These values should be set to a string which may contain :year and :day . These values will be replaced by the day and year of which the input is fetched. For instance, the following configuration will store the fetched input data in my_input/&lt;year&gt;/&lt;day&gt;.input : config :advent_of_code_utils , :code_path , &quot;my_input/:year/:day.input&quot; Session cookie In order to fetch your input, this task needs your advent of code session cookie. This can be obtained by investigating your cookies after logging in on the advent of code website. The cookie can be stored inside your config/config.exs file (e.g. config, :advent_of_code_utils, :session, &quot;&lt;your cookie here&gt;&quot; ) or it can be passed as a command-line argument. If no cookie is present, the input can not be fetched. Example input The example input of a given day is fetched by parsing the challenge webpage of a given day and returning the first code example found on that page. This is generally the example input of that day. As this method is not foolproof, it is sometimes necessary to modify the example file by hand. If you do not wish to fetch example input, you can pass the --no-example flag to this task, or you can set fetch_example to false in the advent_of_code_utils application configuration. Command-line arguments The options below take precedence over values defined in the application configuration. -s or --session : Specify the session cookie. -y or --year : Specify the year. -d or --day : Specify the day. --no-example : Do not fetch example input --example : Fetch example input","ref":"Mix.Tasks.Aoc.Get.html","title":"Mix.Tasks.Aoc.Get","type":"task"},{"doc":"","ref":"Mix.Tasks.Aoc.Get.html#find_example/1","title":"Mix.Tasks.Aoc.Get.find_example/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Aoc.Get.html#run/1","title":"Mix.Tasks.Aoc.Get.run/1","type":"function"},{"doc":"Input fetching and boilerplate generation for Advent of Code . The goal of this project is to eliminate most of the manual labor involved with working on the yearly Advent of Code challenges. As a sample, this is the workflow you'd use when working on the challenge of the first of December 2020: $ mix aoc * Creating: lib/2020/1.ex * Creating: input/2020_1.txt * Creating: input/2020_1_example.txt Today&#39;s challenge can be found at: https://adventofcode.com/2020/day/1 Afterwards, lib/2020/1.ex will look as follows: import AOC aoc 2020 , 1 do def p1 do end def p2 do end end In this generated module, you can access the contents of the fetched input by using input_path/0 , input_string/0 or input_stream/0 . Example input is available through example_path/0 , example_string/0 or example_stream/0 . While solving your challenge, you can use the AOC.IEx.p1/0 and AOC.IEx.p2/0 helpers in iex to quickly test your solution so far. These helpers can also be set up to automatically recompile your mix project. All of this is configurable so that you can adjust this project to fit your own workflow. Check out the docs for more information!","ref":"readme.html","title":"Advent of Code Utils","type":"extras"},{"doc":"Add advent_of_code_utils to your list of dependencies in mix.exs : def deps do [ { :advent_of_code_utils , &quot;~&gt; 2.0&quot; } ] end Store your session cookie in config/config.exs . You can find this by inspecting your cookies after logging in to the advent of code website. config :advent_of_code_utils , session : &quot;&lt;your cookie&gt;&quot; Use mix aoc to work on today's challenge. The day and year of a challenge can be passed in various ways, so this project can still be used when working on older challenges. If you just want to use this application to fetch the input of a challenge, without generating any code, use mix aoc.get instead of mix aoc and ignore the following steps. You probably want to add input/ to your .gitignore file if you use git. Add import AOC.IEx to your .iex.exs file . This allows you to use the utilities defined in AOC.IEx without specifying the module name. (optional) Set auto_compile? in your config/config.exs if you want the various AOC.p* to recompile your project (optional) : config :advent_of_code_utils , auto_compile? : true","ref":"readme.html#installation-use","title":"Advent of Code Utils - Installation &amp; Use","type":"extras"},{"doc":"Besides fetching input, mix aoc.get and mix aoc will also fetch example input for the given day. This is done by reading the first code example on the challenge webpage, which is generally that day's example input. Since this method is not 100% reliable, you may you wish to disable this behaviour. This can be done by passing the --no-example flag to mix aoc or mix aoc.get or by setting fetch_example to false in your config.exs file.","ref":"readme.html#example-input","title":"Advent of Code Utils - Example Input","type":"extras"},{"doc":"This project grew from a collection of utilities I wrote for myself when working on advent of code. I polished these utilities, but it is possible some bugs are still present. If you run into any issue, feel free to create an issue on GitHub .","ref":"readme.html#issues","title":"Advent of Code Utils - Issues","type":"extras"}]